/*
#
#
# By Amaury Carvalho
# Em 03/2007
#
#
*/

#include "text.h"

TTextFile::TTextFile() {
    fileName[0] = 0;
    opened = false;
    close();
}

TTextFile::~TTextFile() {
    close();
}

bool TTextFile::open(char *filename)
{
     int position = 0;
     int i, size;
     
     if(opened)
        close();
               
     strcpy(fileName, filename);
     if(opened = ((arq = fopen(filename, "rb")) != NULL)) {
          
            fseek(arq, 0, SEEK_SET);
            
			while((size = fread(line, 1, MAX_LINE_SIZE, arq)) > 0) {
                        
                      if(count < MAX_LINES) {
                          positions[count] = position;
                          
                          for(i=0; i < size; i++)
                                if(line[i] == 13)
                                    break;
                                    
                          lengths[count] = i;
                          position += i+1;
                          if(line[i+1] == 10) position ++;
                          
                          fseek(arq, position, SEEK_SET);
                          count ++;
                      }
			}
			
     }
     
     return opened;
}
 
void TTextFile::close() 
{
     if(opened) 
         fclose(arq);
     line[0] = 0;
     count = 0;
     opened = false;
}
		         
char * TTextFile::lineText(int lineIndex)
{
     line[0] = 0;
     if(lineIndex < count) {
         if(lengths[lineIndex] > 0) {
            fseek(arq, positions[lineIndex], SEEK_SET);
            if(fread(line, 1, lengths[lineIndex], arq) > 0) 
                line[lengths[lineIndex]] = 0;
         }
     }
     return line;
}

char * TTextFile::lineText(int lineIndex, int start)
{
     return (char *) (lineText(lineIndex) + start);
}

int TTextFile::lineLength(int lineIndex)
{
    int length = 0;
    if(lineIndex < count)
       length = lengths[lineIndex];
    return length;
}

int TTextFile::lineCount()
{
    return count;
}

int TTextFile::searchStart(char *text)
{
    return searchStart(text, 0);
}

int TTextFile::searchStart(char *text, int lineStart)
{
    strcpy(searchText, text);
    searchTextLen = strlen(text);
    searchLine = lineStart;
    return searchNext();
}

int TTextFile::searchNext()
{
    char * s;
    do {
        s = lineText(searchLine++);
        if(!strncmp(s, searchText, searchTextLen)) 
            return searchLine-1;
    } while(searchLine < count);
    return -1;
}

